/*
**	eecho 
*/
#include <stdio.h>
#ifdef BSD
#include <strings.h>
#else
#include <string.h>
#endif
#ifdef MSDOS
#include <fcntl.h>
#endif

int
odigit(p)
char    **p;
{
    int     c;

    for (;;) {
        if ( (c = *(*p)++) == '\0' ) return (-1);
        if ( '0' <= c && c < '7' + 1 ) return (c - '0');
    }
}

void
odoit(p)
char	*p;
{
    int	    c;
    int	    d;

    while ( (c = odigit(&p)) != -1 ) {
        d = c << 6;
        if ( (c = odigit(&p)) == -1 ) {
            putchar(d);
            return ;
        } 
	d += c << 3;
        if  ( (c = odigit(&p)) == -1 ) {
            putchar(d);
            return ;
        }
        putchar(d + c);
    }
    return ;
}

int
xdigit(p)
char    **p;
{
    int     c;

    for (;;) {
        if ( (c = *(*p)++) == '\0' ) return (-1);
        if ( '0' <= c && c < '9' + 1 ) return (c - '0');
        if ( 'A' <= c && c < 'F' + 1 ) return (c - 'A' + 10);
        if ( 'a' <= c && c < 'f' + 1 ) return (c - 'a' + 10);
    }
}

void
xdoit(p)
char	*p;
{
    int	    c;
    int	    d;

    while ( (c = xdigit(&p)) != -1 ) {
        d = c << 4;
        if ( (c = xdigit(&p)) == -1 ) {
            putchar(d);
            return ;
        }
        putchar(d + c);
    }
    return ;
}


void
doit(p)
char	*p;
{
#define get()	(*q++)
#define unget()	--q
static char	*q;

    int	    c;
    int	    d;

    q = p;

    while ( (c = get()) != '\0' ) {
	switch ( c ) {
	    case '^' :
		c = get();
		if ( c == '\0' ) { 
		    putchar('^');
		    return ;
		} else if ( c == '?') {
		    putchar(0x7f); /* del */
		} else {
		    putchar(c & 0x1f); /* ctrl */
		}
		break ;
	    case '\\' :
		c = get();
		if ( c == '\0' ) {
		    putchar('\\');
		    return ;
		} else if ( c == 'a' ) { /* bel */
		    putchar(007);
		} else if ( c == 'b' ) { /* bs */
		    putchar(010);
		} else if ( c == 't' ) { /* ht */
		    putchar(011);
		} else if ( c == 'n' ) { /* nl */
		    putchar(012);
		} else if ( c == 'v' ) { /* vt */
		    putchar(013);
		} else if ( c == 'f' ) { /* ff */
		    putchar(014);
		} else if ( c == 'r' ) { /* cr */
		    putchar(015);
		} else if ( c == 'e' || c == 'E' ) { /* esc */
		    putchar(033);
		} else if ( c == 'x') { /* hexadecimal */
		    d = 0;
		    for (;;) {
			c = get();
			if ( c == '\0' ) {
			    putchar(d);
			    return ;
			} else if ( '0' <= c && c <= '9' ) {
			    d = 16 * d + c - '0';
			} else if ( 'A' <= c && c <= 'F' ) {
			    d = 16 * d + c - 'A' + 10;
			} else if ( 'a' <= c && c <= 'f' ) {
			    d = 16 * d + c - 'a' + 10;
			} else {
			    unget();
			    break ;
			}
		    }
		    putchar(d);
		} else if ( '0' <= c && c <= '7' ) {
		    d = c - '0';
		    if ( (c = get()) == '\0' ) {
			putchar(d);
			return ;
		    } else if ( '0' <= c && c <= '7' ) {
			d = 8 * d + c - '0';
			if ( (c = get()) == '\0' ) {
			    putchar(d);
			    return ;
			} else if ( '0' <= c && c <= '7' ) {
			    d = 8 * d + c - '0';
			} else {
			    unget();
			}
		    } else {
			unget();
		    }
		    putchar(d);
		} else {
		    putchar(c);
		}
		break ;
	    default :
		putchar(c);
		break ;
	}
    }
    return ;
}

int
main(argc,argv)
int argc;
char *argv[];
{
    int	    i;
    int     optf = 1;

#ifdef MSDOS
    setmode(fileno(stdout), O_BINARY);
#endif
    for ( i = 1 ; i < argc ; ++i ) {
        if ( optf && strcmp(argv[i],"--") == 0 ) { /* end of options */
            optf = 0;
            continue;
        }
        if ( optf && strcmp(argv[i],"-x") == 0 && i < argc - 1 ) {
            xdoit(argv[i + 1]);
            ++i;
            continue;
        }
        if ( optf && strcmp(argv[i],"-o") == 0  && i < argc - 1 ) {
            odoit(argv[i + 1]);
            ++i;
            continue;
        }
	doit(argv[i]);
    }
    return (0);
}
